-- Filename: PlayerSpeed.lua
-- Author: SMI Modding Team (Nicola)
-- Date: 10/11/2024
-- version: 1.0.0.0

PlayerSpeed = {}

addModEventListener(PlayerSpeed)


--[[
--- Set speed changing each player informations
-- @param speed of the player (m/s)
function PlayerSpeed.setSpeed(speed)
	--player:getSpeed() si potrebbe sovrascrivere?
	--local info = g_currentMission.playerSystem.playersByUserId[g_currentMission.playerUserId].motionInformation
	local info = nil
	if info ~= nil and speed ~= nil then
		-- Ratio taken from default speeds
		info.maxWalkingSpeed = tonumber(speed)
		info.maxRunningSpeed = tonumber(speed * (9/4))
		info.maxSwimmingSpeed = tonumber(speed * (3/4))
		info.maxCrouchingSpeed = tonumber(speed / 2)
		info.maxFallingSpeed = tonumber(speed * 1.5)
		info.maxCheatRunningSpeed = info.maxRunningSpeed -- Same as maxRunningSpeed
	end
end --]]


function tableToJSON(t, depth)
    local result = {}
    if depth == 0 then
        return "" end


    for key, value in pairs(t) do
        local _k, _v = key, value
        if type(key) == "table" then
            _k = tableToJSON(key, depth-1)
        end
        if type(value) == "table" then
            _v = tableToJSON(value, depth-1)
        end
        -- prepare json key-value pairs and save them in separate table
        table.insert(result, string.format("%s:%s", _k, _v))
    end


    -- get simple json string
    local res_str = "{\n" .. table.concat(result, ",\n") .. "\n}"
    return res_str
end


function PlayerSpeed:keyEvent(unicode, sym, modifier, isDown)
    if Input.isKeyPressed(Input.KEY_lalt) then
		if Input.isKeyPressed(Input.KEY_b) then  -- alternativamente Input.KEY_plus
			local player = g_currentMission.playerSystem.playersByUserId[g_currentMission.playerUserId]
			player.toggleSuperSpeedCommand.value = not player.toggleSuperSpeedCommand.value
		end
	end
end

function PlayerSpeed:update(dt)
	local player = g_currentMission.playerSystem.playersByUserId[g_currentMission.playerUserId]
    local is_controlled = player.isControlled
	if not g_currentMission:getIsClient() or not is_controlled or g_gui.currentGui ~= nil then
        return end

	local activated = player.toggleSuperSpeedCommand.value
	g_currentMission:addExtraPrintText(g_i18n:getText("playerspeed_" .. tostring(activated)))
end
